Foreman - Bug #12478

Virtual interfaces with :attached_to defined can't be updated by

Host::Base.populate_fields_from_facts
11/13/2015 08:29 PM - Brandon Weeks

Status: Closed
Priority: Normal
Assignee: Brandon Weeks
Category: Network
Target version: 1.10.1
Difficulty: trivial Fixed in Releases:
Triaged: Found in Releases: 1.10.0
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/’2912
Description

When a virtual interfaces has a value for :attached_to, it fails to get updated when Host::Base.populate_fields_from_facts runs. This
is because (at least in Puppet environments) the facts table does not contain a value for :attached_to.

The resulting error:

2015-11-13 17:19:14 [sql] [W] Saving bond0 NIC for host host.example.com failed, skipping because:

2015-11-13 17:19:14 [sql] [W] Attached to can't be blank

PR incoming. :)

Associated revisions

Revision a05b0df0 - 11/17/2015 08:50 AM - Brandon Weeks
Fixes #12478 - don't update :attached_to if parsed :attached_to is nil

Revision 928ed680 - 01/19/2016 08:10 AM - Brandon Weeks
Fixes #12478 - don't update :attached_to if parsed :attached_to is nil

(cherry picked from commit a05b0df0462711436b8b4754d717e90a07cd5f4d)

History

#1 - 11/13/2015 09:25 PM - The Foreman Bot
- Status changed from New to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/2912 added

#2 - 11/16/2015 03:58 AM - Dominic Cleal

- translation missing: en.field_release deleted (63)

#3 - 11/16/2015 09:44 PM - The Foreman Bot

- Assignee set to Brandon Weeks

#4 - 11/17/2015 09:01 AM - Brandon Weeks
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset a05b0df0462711436b8b4754d717e90a07cd5f4d.

#5 - 11/17/2015 09:02 AM - Dominic Cleal
https://projects.theforeman.org/projects/foreman/repository/foreman/revisions/a05b0df0462711436b8b4754d717e90a07cd5f4d

- % Done changed from 100 to 0

- translation missing: en.field_release set to 104

#6 - 11/19/2015 09:43 AM - Marek Hulan

FWIW, attached_to is not meant to be set by puppet (or other cfg mgmt tool) but it's constructed from virtual names (e.g. eth0.1 -> eth0), see
https://github.com/brandonweeks/foreman/blob/56671b5f0cfa6dd185cb75d40445300e3b6668f5/app/services/fact_parser.rb#L.126 for more details.
Anyway, thanks for the patch.

#7 - 11/19/2015 02:28 PM - Brandon Weeks

Thanks for the context! Knowing that it's obvious that the problem we were running into is our our virtual interface is named "bond0," do you think
there any other improvements that should be made for handling virtual interfaces that don't have the suffix pattern?

#8 - 11/20/2015 03:43 AM - Marek Hulan

I think your patch fixed it for all interfaces, if | understood it correctly it makes attached_to nil instead of empty string. The other way to fix it would be
to just fix the validation to accept empty strings in this attribute for bonds and bridges but this seems to work just fine :-)
